package dataspork.gui;

import dataspork.interp.InterpreterClass;
import dataspork.interp.Interpreter;
import dataspork.tree.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import java.awt.*;
import java.beans.PropertyChangeListener;
import java.awt.event.*;
import java.util.EventObject;
import java.util.Enumeration;

public class DataTreeGUI extends JTree {
  protected JPopupMenu jpop;

  public DataTreeGUI(DataTreeNode dataTree) {
    super(dataTree);
    jpop = new JPopupMenu();
    setCellEditor(new MyEditor());
    setEditable(true);
  }

  private class MyEditor implements TreeCellEditor {
    protected DataTreeNode node;
    public Component getTreeCellEditorComponent(JTree tree, Object value,
           boolean isSelected, boolean expanded, boolean leaf, int row) {
      node = (DataTreeNode)value;
      return null;
    }
    public void addCellEditorListener(CellEditorListener l) {}
    public void cancelCellEditing() {} 
    public Object getCellEditorValue() {return null;}
    public boolean isCellEditable(EventObject anEvent)  {
      tryPopup(anEvent);
      return false;
    }
    protected void tryPopup(EventObject anEvent) {
      MouseEvent e=(MouseEvent)anEvent;
      if (e!=null) {

        if(node.getNInterpreters() == 1 && e.getClickCount() == 2) {
          Enumeration enum = node.getInterpreters();
	  InterpreterClass interp = (InterpreterClass)enum.nextElement();
	  Interpreter in = interp.getInstance();
	  in.getGUI();	  
        }
        else if(e.isPopupTrigger()  //this may not work on NT, next line is a hack
           || SwingUtilities.isRightMouseButton(e) ) {
          jpop.removeAll();
          Enumeration enum = node.getInterpreters();
          while (enum.hasMoreElements()) {
            jpop.add(new InterpreterRequest(
                              (InterpreterClass)enum.nextElement()));
          }
          jpop.show((Component)e.getSource(),e.getX(),e.getY());
        }
      }
    }
    public void removeCellEditorListener(CellEditorListener l) {}
    public boolean shouldSelectCell(EventObject anEvent) {
      tryPopup(anEvent);
      return true;
    }
    public boolean stopCellEditing() {return true;}
  }

  public class InterpreterRequest implements Action {
    protected InterpreterClass interp;
    public InterpreterRequest(InterpreterClass interp) {
      this.interp=interp;
    }
    public void addPropertyChangeListener(PropertyChangeListener listener){}
    public Object getValue(String key) {
      return key.equals(NAME)?interp.toString():null;
    }
    public boolean isEnabled() {return true;}
    public void putValue(String key, Object value) {}
    public void removePropertyChangeListener(PropertyChangeListener listener){}
    public void setEnabled(boolean b) {}
    public void actionPerformed(ActionEvent event) {
      Interpreter in = interp.getInstance();
      in.getGUI();
    }
  }
}
