package dataspork.gui;
import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

public class ReportGUI {

  protected JPanel mainPane;
  protected JPanel scalarPane;
  protected JComboBox scalarBox;
  protected JPanel scopePane;
  protected JComboBox scopeBox;
  protected JPanel filePane;
  protected JTextField fileField;
  protected JPanel formatPane;
  protected JComboBox formatBox;
  protected JPanel applyPane;
  protected JPanel closePane;
  protected JFrame mainFrame;
  protected MainGUI mGUI;
  protected String defaultFilename = "report.txt";

  public ReportGUI(MainGUI mg) {
    
    mainFrame = new JFrame("Print Report");
    this.mGUI = mg;

    mainPane = new JPanel();
    mainPane.setLayout(new BoxLayout(mainPane,BoxLayout.Y_AXIS));
    mainPane.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));

    scalarPane = new JPanel();
    scalarPane.setLayout(new BoxLayout(scalarPane,BoxLayout.X_AXIS));
    JLabel scalarLabel = new JLabel("Scalar:");
    String[] scalarItems = {"current","all"};
    scalarBox = new JComboBox(scalarItems);
    scalarBox.setEditable(false);
    scalarPane.add(scalarLabel);
    scalarPane.add(Box.createRigidArea(new Dimension(5,0)));
    scalarPane.add(Box.createHorizontalGlue());
    scalarPane.add(scalarBox);

    scopePane = new JPanel();
    scopePane.setLayout(new BoxLayout(scopePane,BoxLayout.X_AXIS));
    JLabel scopeLabel = new JLabel("Tab:");
    String[] scopeItems = {"current","all"};
    scopeBox = new JComboBox(scopeItems);
    scopeBox.setEditable(false);
    scopePane.add(scopeLabel);
    scopePane.add(Box.createRigidArea(new Dimension(5,0)));
    scopePane.add(Box.createHorizontalGlue());
    scopePane.add(scopeBox);

    filePane = new JPanel();
    filePane.setLayout(new BoxLayout(filePane,BoxLayout.X_AXIS));
    JLabel fileLabel = new JLabel("Report Filename:");
    fileField = new JTextField(20);
    fileField.setText(this.defaultFilename);
    fileField.setMaximumSize(new Dimension(250,40));
    filePane.add(fileLabel);
    filePane.add(Box.createRigidArea(new Dimension(5,0)));
    filePane.add(Box.createHorizontalGlue());
    filePane.add(fileField);

    formatPane = new JPanel();
    formatPane.setLayout(new BoxLayout(formatPane,BoxLayout.X_AXIS));
    JLabel formatLabel = new JLabel("File format:");
    String[] formatItems = {"ascii"};
    formatBox = new JComboBox(formatItems);
    formatBox.setEditable(false);
    formatPane.add(formatLabel);
    formatPane.add(Box.createRigidArea(new Dimension(5,0)));
    formatPane.add(Box.createHorizontalGlue());
    formatPane.add(formatBox);

    applyPane = new JPanel();
    applyPane.setLayout(new BoxLayout(applyPane,BoxLayout.X_AXIS));
    JButton applyButton = new JButton("Apply");
    applyButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        try {
          boolean allTabs = false;
          String boxSelection = (String)scopeBox.getSelectedItem();
          if (boxSelection.equals("all")) { allTabs = true; }
          boolean allScalars = false;
          String boxSelection2 = (String)scalarBox.getSelectedItem();
          if (boxSelection2.equals("all")) { allScalars = true; }

          mGUI.printReport((String)fileField.getText(),allTabs,allScalars,true);

        }
        catch(NumberFormatException enum) {}
      }
    });
    applyPane.add(Box.createHorizontalGlue());
    applyPane.add(applyButton);

    closePane = new JPanel();
    closePane.setLayout(new BoxLayout(closePane,BoxLayout.X_AXIS));
    JButton closeButton = new JButton("Close");
    closeButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Runnable hideFrame = new Runnable() {
          public void run() {mainFrame.setVisible(false);}
        };
        SwingUtilities.invokeLater(hideFrame);
      }
    });
    closePane.add(Box.createHorizontalGlue());
    closePane.add(closeButton);

    mainPane.add(scopePane);
    mainPane.add(Box.createRigidArea(new Dimension(0,5)));
    mainPane.add(scalarPane);
    mainPane.add(Box.createRigidArea(new Dimension(0,5)));
    mainPane.add(filePane);
    mainPane.add(Box.createRigidArea(new Dimension(0,5)));
    mainPane.add(formatPane);
    mainPane.add(Box.createRigidArea(new Dimension(0,10)));
    mainPane.add(Box.createVerticalGlue());
    mainPane.add(applyPane);
    mainPane.add(Box.createRigidArea(new Dimension(0,5)));
    mainPane.add(closePane);

    mainFrame.getContentPane().add(mainPane, BorderLayout.CENTER);

    mainFrame.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        Runnable hideFrame = new Runnable() {
          public void run() {mainFrame.setVisible(false);}
        };
        SwingUtilities.invokeLater(hideFrame);
      }
    });

    mainFrame.pack();
    mainFrame.show();

  }

}
