package dataspork.interp;
import dataspork.tree.DataTreeNode;
import dataspork.gui.InterpreterGUI;
import dataspork.gui.ScalarDatasetGUI;
import dataspork.stat.ScalarSeries;

public class ScalarDataset extends ScalarSeries implements Interpreter {

  protected DataTreeNode node;
  protected InterpreterGUI gui;

  protected boolean reportFlag = true;

  public ScalarDataset(DataTreeNode node) {
    super((double[])node.getDataSource().getData());
    this.node = node;
  }

  public InterpreterGUI getGUI() {
    if (super.hasData) {
      if (gui==null) {gui=new ScalarDatasetGUI(this);}
      else {gui.show();}
      return gui;
    }
    else {
      System.out.println("Unable to plot scalar -- no data.");
      return null;
    }
  }

  public boolean canReport() {
    return reportFlag;
  }

  public void noReport() {
    reportFlag = false;
  }

  public String getName() {
    //    return node.toString();
    return node.getLongName();
  }

}
