
package dataspork.util;

import javax.swing.event.EventListenerList;
import java.util.EventListener;
import dataspork.util.DataListener;

/** Model for storing dr and the beginning configuration cutoff for g(r). */

public class grModel {

   protected double dr;
   protected int cutoff;
   protected int cutoff_max;
   protected EventListenerList listenerList;

   public grModel (double dr, int cutoff, int cutmax) {
       this.dr = dr;
       this.cutoff = cutoff;
       cutoff_max = cutmax;
       listenerList = new EventListenerList();
   }

   public double getdr(){
      return dr;
   }

   public int getCutoff(){
      return cutoff;
   }

   public void setdr(double dr){
       double olddr;
       olddr = this.dr;
       if (dr>0.0)  { this.dr = dr;}

       if (olddr!=dr) {
          fireListeners();
       }
   }
   public void setCutoff(int cut){
       int oldcut = this.cutoff;
       if (cut>=0 )  { this.cutoff = cut;}
       if ( (cut>cutoff_max) && (cutoff_max!=0))  {this.cutoff=cutoff_max;}

       if (oldcut!=cut) {
          fireListeners();
       }
   }
   public void addListener(DataListener e){
      listenerList.add(DataListener.class,e);
   }

   protected void fireListeners(){
      Object[] listeners  = listenerList.getListenerList();
      for (int i=listeners.length-2;i>=0; i-=2){
         ((DataListener)listeners[i+1]).dataChanged(this);
      }
   }




}
