/****************************************************************************
 * NCSA HDF                                                                 *
 * National Comptational Science Alliance                                   *
 * University of Illinois at Urbana-Champaign                               *
 * 605 E. Springfield, Champaign IL 61820                                   *
 *                                                                          *
 * For conditions of distribution and use, see the accompanying             *
 * hdf/COPYING file.                                                        *
 *                                                                          *
 ****************************************************************************/

package ncsa.hdf.message;

/**
 *  HDFVgroup is an abstract HDF object. It does not has its
 *  only data but references to other HDF data object
 
 *  @version   1.1.3 September 22 1997
 *  @author    Peter X. Cao
 */
public class HDFVgroup extends HDFObject
{
    /**
     *  Constructs an HDFVgroup with default parameters
     */
    public HDFVgroup ()
    {
        super();
    }

    /**
     *  Construct an HDFVgroup with specified HDFObjectNode and filename
     *
     *  @param node     the HDFObjectNode to be transfered to the server
     *  @param filename the requested HDF file
     */
    public HDFVgroup (HDFObjectNode node, String filename)
    {
        super(node, filename);
        information = "";
    }
}
