package pupi.reader.restart;
import dataspork.tree.*;
import dataspork.reader.*;
import java.util.Stack;

public class RSRawDocHandler implements HDFDocHandler {
  protected DataTreeNode root;
  protected DataTreeNode node;
  protected Stack stack;

  public RSRawDocHandler() {
    stack = new Stack();
  }

  public DataTreeNode getDataTree() {
    return root;
  }  

  public void startElement(HDFParser.Element e) {
    //Save the previous node on stack.
    if (node!=null) stack.push(node);
    createNewNode(e);
  }

  public void endElement(HDFParser.Element e) {
    //Retrieve previous node from stack.
    node = stack.empty() ? null : (DataTreeNode)stack.pop();
  }

  protected void createNewNode(HDFParser.Element e) {
    DataTreeNode newNode = new DataTreeNode(e.toString());
    if (node!=null) {
      node.add(newNode);
    } else {
      root=newNode;
    }
    node = newNode;
  }

  public void startDocument() {
  }

  public void endDocument() {
  }

}
